'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.withSpinner = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _path = require('ramda/src/path');

var _path2 = _interopRequireDefault(_path);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _wrapDisplayName = require('recompose/wrapDisplayName');

var _wrapDisplayName2 = _interopRequireDefault(_wrapDisplayName);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getDataProperty(propName, props) {
    return Array.isArray(propName) ? (0, _path2.default)(propName, props) : props[propName];
}
var withSpinner = exports.withSpinner = function withSpinner(_ref) {
    var _ref$prop = _ref.prop,
        prop = _ref$prop === undefined ? 'data' : _ref$prop,
        _ref$timeout = _ref.timeout,
        timeout = _ref$timeout === undefined ? 100 : _ref$timeout,
        _ref$handleError = _ref.handleError,
        handleError = _ref$handleError === undefined ? true : _ref$handleError,
        _ref$partial = _ref.partial,
        partial = _ref$partial === undefined ? false : _ref$partial,
        skipErrors = _ref.skipErrors,
        spinnerProps = _ref.spinnerProps,
        _ref$errorComponent = _ref.errorComponent,
        ErrorComponent = _ref$errorComponent === undefined ? null : _ref$errorComponent,
        Spinner = _ref.spinnerComponent,
        _ref$emptyComponent = _ref.emptyComponent,
        EmptyComponent = _ref$emptyComponent === undefined ? null : _ref$emptyComponent;
    return function (WrappedComponent) {
        var _a;return _a = function (_Component) {
            _inherits(_a, _Component);

            function _a() {
                _classCallCheck(this, _a);

                var _this = _possibleConstructorReturn(this, (_a.__proto__ || Object.getPrototypeOf(_a)).apply(this, arguments));

                _this.state = { showSpinner: false };
                _this.timeout = null;
                return _this;
            }

            _createClass(_a, [{
                key: 'componentWillReceiveProps',
                value: function componentWillReceiveProps(nextProps) {
                    var dataProp = this.props.prop || prop;
                    var data = getDataProperty(dataProp, this.props);
                    if (!getDataProperty(dataProp, nextProps) && data && (partial || !data.loading)) {
                        this.timeout = null;
                        if (this.state.showSpinner) {
                            this.setState({ showSpinner: false });
                        }
                    }
                }
            }, {
                key: 'render',
                value: function render() {
                    var _this2 = this;

                    var dataProp = this.props.prop || prop;
                    var data = getDataProperty(dataProp, this.props);
                    if (data && (partial || !data.loading)) {
                        if (Array.isArray(data) && !data.length && EmptyComponent || !Object.keys(data).length && EmptyComponent) {
                            return EmptyComponent && React.createElement(EmptyComponent, this.props);
                        } else if (!handleError || !data.error || !!(typeof skipErrors === 'function' && skipErrors(data))) {
                            return React.createElement(WrappedComponent, this.props);
                        }
                        return ErrorComponent && React.createElement(ErrorComponent, this.props);
                    }
                    if (this.state.showSpinner) return React.createElement(Spinner, _extends({}, spinnerProps, this.props));
                    if (this.timeout === null) {
                        this.timeout = window.setTimeout(function () {
                            _this2.setState({ showSpinner: true });
                        }, timeout);
                    }
                    return null;
                }
            }]);

            return _a;
        }(_react.Component), _a.displayName = (0, _wrapDisplayName2.default)(WrappedComponent, 'withSpinner'), _a;
    };
};
//# sourceMappingURL=index.js.map
