'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('./test-setup');

var _enzyme = require('enzyme');

var _enzymeToJson = require('enzyme-to-json');

var _enzymeToJson2 = _interopRequireDefault(_enzymeToJson);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _compose = require('recompose/compose');

var _compose2 = _interopRequireDefault(_compose);

var _defaultProps = require('recompose/defaultProps');

var _defaultProps2 = _interopRequireDefault(_defaultProps);

var _index = require('./index');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // jsdom, needs to be imported first


var Loading = function Loading() {
    return React.createElement(
        'span',
        null,
        'Loading...'
    );
};
jest.useFakeTimers();
describe('withSpinner', function () {
    it('should render spinner if loading is true', function () {
        var Component = (0, _compose2.default)((0, _defaultProps2.default)({ data: { loading: true } }), (0, _index.withSpinner)({ spinnerComponent: Loading }))(function () {
            return React.createElement('div', null);
        });
        var wrapper = (0, _enzyme.shallow)(React.createElement(Component, null)).first().shallow();
        expect(wrapper.type()).toBeNull();
        // Run timer so it passes withSpinner timeout
        jest.runTimersToTime(100);
        wrapper.update();
        expect((0, _enzymeToJson2.default)(wrapper)).toMatchSnapshot();
    });
    it('should not render spinner if loading is false', function () {
        var Component = (0, _compose2.default)((0, _defaultProps2.default)({ data: { loading: false } }), (0, _index.withSpinner)({ spinnerComponent: Loading }))(function (_ref) {
            var data = _ref.data;
            return React.createElement(
                'div',
                null,
                'loading: ',
                data.loading.toString()
            );
        });
        var wrapper = (0, _enzyme.shallow)(React.createElement(Component, null)).first().shallow().first().shallow();
        wrapper.update();
        expect((0, _enzymeToJson2.default)(wrapper)).toMatchSnapshot();
    });
    it('should render spinner in 100 ms and after render component', function () {
        var DisplayComponent = function DisplayComponent(_ref2) {
            var data = _ref2.data;
            return React.createElement(
                'div',
                null,
                'loading: ',
                data.loading.toString(),
                ', item: ',
                data.item.id
            );
        };
        var Component = (0, _compose2.default)(function (WrappedComponent) {
            return function (_React$Component) {
                _inherits(_class, _React$Component);

                function _class() {
                    _classCallCheck(this, _class);

                    var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).apply(this, arguments));

                    _this.state = { loading: true, item: null };
                    return _this;
                }

                _createClass(_class, [{
                    key: 'componentDidMount',
                    value: function componentDidMount() {
                        var _this2 = this;

                        // Delay setting loading to false.
                        setTimeout(function () {
                            _this2.setState({ loading: false, item: { id: 1 } });
                        }, 1000);
                    }
                }, {
                    key: 'render',
                    value: function render() {
                        return React.createElement(WrappedComponent, _extends({}, this.props, { data: { loading: this.state.loading, item: this.state.item } }));
                    }
                }]);

                return _class;
            }(React.Component);
        }, (0, _index.withSpinner)({ spinnerComponent: Loading }))(DisplayComponent);
        var wrapper = (0, _enzyme.mount)(React.createElement(Component, null));
        // Should not display a Spinner
        expect(wrapper.html()).toBeNull();
        // Run timer to 100 ms since withSpinner timeout defaults to 100 ms
        jest.runTimersToTime(100);
        // ProgressBar should now be found
        wrapper = wrapper.update();
        expect(wrapper.find(Loading)).toHaveLength(1);
        expect(wrapper.find(DisplayComponent)).toHaveLength(0);
        // Run timer to 1000 ms for our own timeout
        jest.runTimersToTime(1000);
        wrapper = wrapper.update();
        // DisplayComponent should be found
        expect(wrapper.find(DisplayComponent)).toHaveLength(1);
        expect(wrapper.find(Loading)).toHaveLength(0);
        expect((0, _enzymeToJson2.default)(wrapper)).toMatchSnapshot();
    });
    it('should render passed spinnerComponent', function () {
        var Loading = function Loading() {
            return React.createElement(
                'span',
                null,
                'Loading...'
            );
        };
        var Component = (0, _compose2.default)((0, _defaultProps2.default)({ data: { loading: true } }), (0, _index.withSpinner)({ spinnerComponent: Loading }))(null);
        var wrapper = (0, _enzyme.shallow)(React.createElement(Component, null)).first().shallow();
        jest.runTimersToTime(100);
        expect((0, _enzymeToJson2.default)(wrapper)).toMatchSnapshot();
    });
    it('should ignore errors if handleError is false', function () {
        var DisplayComponent = function DisplayComponent(_ref3) {
            var data = _ref3.data;
            return React.createElement(
                'div',
                null,
                'loading: ',
                data.loading.toString(),
                ', item: ',
                data.item.id
            );
        };
        var Component = (0, _compose2.default)((0, _defaultProps2.default)({ data: { loading: false, error: true } }), (0, _index.withSpinner)({ spinnerComponent: Loading, handleError: false }))(DisplayComponent);
        var wrapper = (0, _enzyme.shallow)(React.createElement(Component, null)).first().shallow();
        jest.runTimersToTime(100);
        expect((0, _enzymeToJson2.default)(wrapper)).toMatchSnapshot();
    });
    it('should render passed errorComponent if error exists', function () {
        var ErrorComponent = function ErrorComponent() {
            return React.createElement(
                'span',
                null,
                'An unknown error occured...'
            );
        };
        var Component = (0, _compose2.default)((0, _defaultProps2.default)({ data: { loading: false, error: true } }), (0, _index.withSpinner)({ spinnerComponent: Loading, errorComponent: ErrorComponent }))(null);
        var wrapper = (0, _enzyme.shallow)(React.createElement(Component, null)).first().shallow();
        jest.runTimersToTime(100);
        expect(wrapper.find(ErrorComponent)).toHaveLength(1);
        expect((0, _enzymeToJson2.default)(wrapper)).toMatchSnapshot();
    });
    it('should delay rendering of spinnerComponent the timeout that is passed', function () {
        var DisplayComponent = function DisplayComponent(_ref4) {
            var data = _ref4.data;
            return React.createElement(
                'div',
                null,
                'loading: ',
                data.loading.toString(),
                ', item: ',
                data.item.id
            );
        };
        var Component = (0, _compose2.default)((0, _defaultProps2.default)({ data: { loading: true } }), (0, _index.withSpinner)({ spinnerComponent: Loading, timeout: 500 }))(DisplayComponent);
        var wrapper = (0, _enzyme.shallow)(React.createElement(Component, null)).first().shallow();
        // Run timer to a time before our timeout
        jest.runTimersToTime(400);
        expect(wrapper.type()).toBeNull();
        // Run timer over our timeout
        jest.runTimersToTime(600);
        expect(wrapper.first().shallow().getElement()).toEqual(Loading());
    });
    it('should not render errorComponent if skipErrors returns true', function () {
        var validationError = { validationError: { field: 'password', message: 'Wrong password' } };
        var ErrorComponent = function ErrorComponent() {
            return React.createElement(
                'span',
                null,
                'An unknown error occured...'
            );
        };
        var DisplayComponent = function DisplayComponent(_ref5) {
            var error = _ref5.data.error;
            return React.createElement(
                'div',
                null,
                'Validation error occured on field: ',
                error.validationError.field,
                ' with message: ',
                error.validationError.message
            );
        };
        var Component = (0, _compose2.default)((0, _defaultProps2.default)({ data: { loading: false, error: validationError } }), (0, _index.withSpinner)({ spinnerComponent: Loading,
            errorComponent: ErrorComponent,
            skipErrors: function skipErrors(data) {
                return data.error.validationError && data.error.validationError.field === 'password';
            }
        }))(DisplayComponent);
        var wrapper = (0, _enzyme.shallow)(React.createElement(Component, null)).first().shallow();
        jest.runTimersToTime(100);
        expect(wrapper.find(ErrorComponent)).toHaveLength(0);
        expect((0, _enzymeToJson2.default)(wrapper.first().shallow())).toMatchSnapshot();
    });
    it('should support custom loading property', function () {
        var DisplayComponent = function DisplayComponent(_ref6) {
            var result = _ref6.result;
            return React.createElement(
                'div',
                null,
                'loading: ',
                result.loading.toString(),
                ', item: ',
                result.item.id
            );
        };
        var Component = (0, _compose2.default)(function (WrappedComponent) {
            return function (_React$Component2) {
                _inherits(_class2, _React$Component2);

                function _class2() {
                    _classCallCheck(this, _class2);

                    var _this3 = _possibleConstructorReturn(this, (_class2.__proto__ || Object.getPrototypeOf(_class2)).apply(this, arguments));

                    _this3.state = { loading: true, item: null };
                    return _this3;
                }

                _createClass(_class2, [{
                    key: 'componentDidMount',
                    value: function componentDidMount() {
                        var _this4 = this;

                        // Delay setting loading to false.
                        setTimeout(function () {
                            _this4.setState({ loading: false, item: { id: 1 } });
                        }, 1000);
                    }
                }, {
                    key: 'render',
                    value: function render() {
                        return React.createElement(WrappedComponent, _extends({}, this.props, { result: { loading: this.state.loading, item: this.state.item } }));
                    }
                }]);

                return _class2;
            }(React.Component);
        }, (0, _index.withSpinner)({ spinnerComponent: Loading, prop: 'result' }))(DisplayComponent);
        var wrapper = (0, _enzyme.mount)(React.createElement(Component, null));
        // Should not display a Spinner
        expect(wrapper.html()).toBeNull();
        // Run timer to 100 ms since withSpinner timeout defaults to 100 ms
        jest.runTimersToTime(100);
        wrapper = wrapper.update();
        // ProgressBar should now be found
        expect(wrapper.find(Loading)).toHaveLength(1);
        expect(wrapper.find(DisplayComponent)).toHaveLength(0);
        // Run timer to 1000 ms for our own timeout
        jest.runTimersToTime(1000);
        wrapper = wrapper.update();
        // DisplayComponent should be found
        expect(wrapper.find(DisplayComponent)).toHaveLength(1);
        expect(wrapper.find(Loading)).toHaveLength(0);
    });
    it('should support custom nested loading property', function () {
        var DisplayComponent = function DisplayComponent(_ref7) {
            var result = _ref7.result;
            return React.createElement(
                'div',
                null,
                'loading: ',
                result.nested.loading.toString(),
                ', item: ',
                result.nested.item && result.nested.item.id
            );
        };
        var Component = (0, _compose2.default)(function (WrappedComponent) {
            return function (_React$Component3) {
                _inherits(_class3, _React$Component3);

                function _class3() {
                    _classCallCheck(this, _class3);

                    var _this5 = _possibleConstructorReturn(this, (_class3.__proto__ || Object.getPrototypeOf(_class3)).apply(this, arguments));

                    _this5.state = { loading: true, item: null };
                    return _this5;
                }

                _createClass(_class3, [{
                    key: 'componentDidMount',
                    value: function componentDidMount() {
                        var _this6 = this;

                        // Delay setting loading to false.
                        setTimeout(function () {
                            _this6.setState({ loading: false, item: { id: 1 } });
                        }, 1000);
                    }
                }, {
                    key: 'render',
                    value: function render() {
                        // return <WrappedComponent {...this.props} data={{loading: this.state.loading, item: this.state.item}} />
                        return React.createElement(WrappedComponent, _extends({}, this.props, { result: { nested: { loading: this.state.loading, item: this.state.item } } }));
                    }
                }]);

                return _class3;
            }(React.Component);
        }, (0, _index.withSpinner)({ spinnerComponent: Loading, prop: ['result', 'nested'] }))(DisplayComponent);
        var wrapper = (0, _enzyme.mount)(React.createElement(Component, null));
        // Should not display a Spinner
        expect(wrapper.html()).toBeNull();
        // Run timer to 100 ms since withSpinner timeout defaults to 100 ms
        jest.runTimersToTime(100);
        wrapper = wrapper.update();
        // ProgressBar should now be found
        expect(wrapper.find(Loading)).toHaveLength(1);
        expect(wrapper.find(DisplayComponent)).toHaveLength(0);
        // Run timer to 1000 ms for our own timeout
        jest.runTimersToTime(1000);
        wrapper = wrapper.update();
        // DisplayComponent should be found
        expect(wrapper.find(DisplayComponent)).toHaveLength(1);
        expect(wrapper.find(Loading)).toHaveLength(0);
        expect((0, _enzymeToJson2.default)(wrapper)).toMatchSnapshot();
    });
    it('should render a emptyComponent if data i empty', function () {
        var EmptyComponent = function EmptyComponent() {
            return React.createElement(
                'span',
                null,
                'No data...'
            );
        };
        var Component = (0, _compose2.default)((0, _defaultProps2.default)({ data: { loading: false, value: {} } }), (0, _index.withSpinner)({ spinnerComponent: Loading, emptyComponent: EmptyComponent, prop: ['data', 'value'] }))(null);
        var wrapper = (0, _enzyme.shallow)(React.createElement(Component, null)).first().shallow();
        jest.runTimersToTime(100);
        expect(wrapper.find(EmptyComponent)).toHaveLength(1);
        expect((0, _enzymeToJson2.default)(wrapper)).toMatchSnapshot();
    });
});
//# sourceMappingURL=index.test.js.map
